<template>
	<xn-form-container
		:title="'编辑提货配置'"
		:width="700"
		v-model:open="open"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-descriptions :column="4" size="middle" bordered class="mb-2" :label-style="labelStyle" :contentStyle="contentStyle">
			<a-descriptions-item label="货品编码" :span="4">{{ formData.goodsCode }}</a-descriptions-item>
			<a-descriptions-item label="货品信息" :span="4">{{ formData.goodsName }} （{{ formData.goodsModel }}）</a-descriptions-item>
		</a-descriptions>

		<a-form ref="formRef" :model="formData" :rules="formRules" :wrapper-col="wrapperCol" :label-col="labelCol">
			<a-form-item label="提货开始时间：" name="confStartTime">
				<a-date-picker v-model:value="formData.confStartTime" value-format="YYYY-MM-DD HH:mm" show-time style="width: 100%" />
			</a-form-item>
			<a-form-item label="提货结束时间：" name="confEndTime">
				<a-date-picker v-model:value="formData.confEndTime" value-format="YYYY-MM-DD HH:mm" show-time style="width: 100%" />
			</a-form-item>
			<a-form-item label="最大提货重量(KG)：" name="confWeight">
				<a-input v-model:value="formData.confWeight" :min="formData.usedWeight" placeholder="请输入最大提货重量" allow-clear />
			</a-form-item>
		</a-form>

		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="goodsConfForm">
	import { cloneDeep } from 'lodash-es'
	import { message } from 'ant-design-vue'
	import { required } from '@/utils/formRules'
	import goodsConfApi from '@/api/biz/goodsConfApi'

	// 抽屉状态
	const open = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({})
	const submitLoading = ref(false)

	//设置表单样式
	const labelCol = ref({ span: 5})
	const wrapperCol = ref({ span: 16})

	// 打开抽屉
	const onOpen = (record) => {
		open.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		}
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		open.value = false
	}
	// 默认要校验的
	const formRules = {
		confStartTime: [required('请选择提货开始时间')],
		confEndTime: [required('请选择提货结束时间')],
		confWeight: [required('请输入最大提货重量')],
	}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value
			.validate()
			.then(() => {
				submitLoading.value = true
				const formDataParam = cloneDeep(formData.value)
				// 判断开始和结束时间
				let confStartTime = new Date(formDataParam.confStartTime+":00")
				let confEndTime = new Date(formDataParam.confEndTime+":00")
				if(confStartTime > confEndTime){
					message.error('结束时间不得小于开始时间！')
					return
				}else{
					goodsConfApi
					.goodsConfSubmitForm(formDataParam, formDataParam.id)
					.then(() => {
						onClose()
						emit('successful')
					})
					.finally(() => {
						submitLoading.value = false
					})
				}
			})
			.catch(() => {})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
